/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-02-29 at 05:50:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.composer.v1beta1.model;

/**
 * The ImageVersions in a project and location.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Composer API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ListImageVersionsResponse extends com.google.api.client.json.GenericJson {

  /**
   * The list of supported ImageVersions in a location.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<ImageVersion> imageVersions;

  static {
    // hack to force ProGuard to consider ImageVersion used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(ImageVersion.class);
  }

  /**
   * The page token used to query for the next page if one exists.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The list of supported ImageVersions in a location.
   * @return value or {@code null} for none
   */
  public java.util.List<ImageVersion> getImageVersions() {
    return imageVersions;
  }

  /**
   * The list of supported ImageVersions in a location.
   * @param imageVersions imageVersions or {@code null} for none
   */
  public ListImageVersionsResponse setImageVersions(java.util.List<ImageVersion> imageVersions) {
    this.imageVersions = imageVersions;
    return this;
  }

  /**
   * The page token used to query for the next page if one exists.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * The page token used to query for the next page if one exists.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public ListImageVersionsResponse setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public ListImageVersionsResponse set(String fieldName, Object value) {
    return (ListImageVersionsResponse) super.set(fieldName, value);
  }

  @Override
  public ListImageVersionsResponse clone() {
    return (ListImageVersionsResponse) super.clone();
  }

}
