/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-02-29 at 05:50:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.composer.v1beta1.model;

/**
 * The configuration information for configuring a Private IP Cloud Composer environment.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Composer API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PrivateEnvironmentConfig extends com.google.api.client.json.GenericJson {

  /**
   * Optional. If `true`, a Private IP Cloud Composer environment is created. If this field is true,
   * `use_ip_aliases` must be true.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean enablePrivateEnvironment;

  /**
   * Optional. Configuration for the private GKE cluster for a Private IP Cloud Composer
   * environment.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private PrivateClusterConfig privateClusterConfig;

  /**
   * Optional. If `true`, a Private IP Cloud Composer environment is created. If this field is true,
   * `use_ip_aliases` must be true.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEnablePrivateEnvironment() {
    return enablePrivateEnvironment;
  }

  /**
   * Optional. If `true`, a Private IP Cloud Composer environment is created. If this field is true,
   * `use_ip_aliases` must be true.
   * @param enablePrivateEnvironment enablePrivateEnvironment or {@code null} for none
   */
  public PrivateEnvironmentConfig setEnablePrivateEnvironment(java.lang.Boolean enablePrivateEnvironment) {
    this.enablePrivateEnvironment = enablePrivateEnvironment;
    return this;
  }

  /**
   * Optional. Configuration for the private GKE cluster for a Private IP Cloud Composer
   * environment.
   * @return value or {@code null} for none
   */
  public PrivateClusterConfig getPrivateClusterConfig() {
    return privateClusterConfig;
  }

  /**
   * Optional. Configuration for the private GKE cluster for a Private IP Cloud Composer
   * environment.
   * @param privateClusterConfig privateClusterConfig or {@code null} for none
   */
  public PrivateEnvironmentConfig setPrivateClusterConfig(PrivateClusterConfig privateClusterConfig) {
    this.privateClusterConfig = privateClusterConfig;
    return this;
  }

  @Override
  public PrivateEnvironmentConfig set(String fieldName, Object value) {
    return (PrivateEnvironmentConfig) super.set(fieldName, value);
  }

  @Override
  public PrivateEnvironmentConfig clone() {
    return (PrivateEnvironmentConfig) super.clone();
  }

}
