/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-02-29 at 05:50:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.composer.v1beta1.model;

/**
 * Network-level access control policy for the Airflow web server.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Composer API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class WebServerNetworkAccessControl extends com.google.api.client.json.GenericJson {

  /**
   * A collection of allowed IP ranges with descriptions.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<AllowedIpRange> allowedIpRanges;

  /**
   * A collection of allowed IP ranges with descriptions.
   * @return value or {@code null} for none
   */
  public java.util.List<AllowedIpRange> getAllowedIpRanges() {
    return allowedIpRanges;
  }

  /**
   * A collection of allowed IP ranges with descriptions.
   * @param allowedIpRanges allowedIpRanges or {@code null} for none
   */
  public WebServerNetworkAccessControl setAllowedIpRanges(java.util.List<AllowedIpRange> allowedIpRanges) {
    this.allowedIpRanges = allowedIpRanges;
    return this;
  }

  @Override
  public WebServerNetworkAccessControl set(String fieldName, Object value) {
    return (WebServerNetworkAccessControl) super.set(fieldName, value);
  }

  @Override
  public WebServerNetworkAccessControl clone() {
    return (WebServerNetworkAccessControl) super.clone();
  }

}
